;; Problem 37
;; 14 February 2003

;; The number 3797 has an interesting property. Being prime itself, it is possible to continuously remove digits from left to right, and remain prime at each stage: 3797, 797, 97, and 7. Similarly we can work from right to left: 3797, 379, 37, and 3.

;; Find the sum of the only eleven primes that are both truncatable from left to right and right to left.

;; NOTE: 2, 3, 5, and 7 are not considered to be truncatable primes.


;; going to cheat/brute force, there is a prime spigot from an earlier
;; problem that I used to gen a list of primes...


(defvar *primes* "/home/mortis/personal/projects/project-euler/prms.txt")

(defun char->digit (chr)
  (cond
    ((eq #\1 chr) 1)
    ((eq #\2 chr) 2)
    ((eq #\3 chr) 3)
    ((eq #\4 chr) 4)
    ((eq #\5 chr) 5)
    ((eq #\6 chr) 6)
    ((eq #\7 chr) 7)
    ((eq #\8 chr) 8)
    ((eq #\9 chr) 9)
    ((eq #\0 chr) 0)
    (t
     (error "unsupported char: ~a~&" chr))))

(defun explode-num (num)
  (let ((str (format nil "~d" num)))
    (loop for ii from 0 to (- (length str) 1)
	  collect (char->digit (char str ii)))))

   ;; a prime can't end in 0,2,4,6,or 8

  (loop for dig in (explode-num num)
	for parts = (list dig) then (cons dig parts)
	do
	
(defun load-primes ()
  (let ((ht (make-hash-table :test #'equal)))
    (with-open-file (in *primes* :direction :input)
      (loop for line = (read-line in nil nil)
	    while line
	    do
	    (let ((num (read-from-string line)))
	      (setf (gethash num ht) t))))
    ht))

(defvar *primes-table* (load-primes))

(defun list->num (lst)
  (read-from-string (format nil "~{~d~}" lst)))

(assert (= 123 (list->num '(1 2 3))))

(defun truncatable? (num)
  (if (< num 10)
      (return-from truncatable? nil))
  (let ((digits (explode-num num)))
    (loop 
     for digit in digits
     for pdigs = (list digit) then (cons digit pdigs)
     do
;;      (format t "left: ~a ? ~a~&" pdigs
;; 		(list->num (reverse pdigs)))
     (when (not (gethash (list->num (reverse pdigs)) *primes-table*))
       (return-from truncatable? nil)))
    (loop
     for digit in (reverse digits)
     for pdigs = (list digit) then (cons digit pdigs)
     do
;;      (format t "right: ~a ? ~a~&" pdigs
;; 		(list->num pdigs))
     (when (not (gethash (list->num pdigs) *primes-table*))
       (return-from truncatable? nil)))
    t))

; (truncatable? 3797)

(time
 (let ((res (list)))
   (loop for prime being the hash-keys of *primes-table*
	 while (< (length res) 11)
	 do
	 (when (truncatable? prime)
	   (push prime res)
	   (format t "truncatable:~a : ~a~&" prime (length res))))
   (format t "res:~a~&" res)
   res))

; (+ 739397 3797 3137 797 373 317 313 73 53 37 23) ;; 748317
